diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/uan/bindings/modulegen__gcc_LP64.py ns-3.33/src/uan/bindings/modulegen__gcc_LP64.py
--- ns-3.32/src/uan/bindings/modulegen__gcc_LP64.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/uan/bindings/modulegen__gcc_LP64.py	2021-01-09 10:19:22.000000000 -0800
@@ -9179,12 +9214,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::Mac8Address, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::Packet> arg0, ns3::Mac8Address arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('ns3::Mac8Address', 'arg1')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Ns3UanTxMode_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9201,12 +9236,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::UanTxMode, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::Packet> arg0, ns3::UanTxMode arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('ns3::UanTxMode', 'arg1')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9223,12 +9258,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::Packet> arg0) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_int_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9245,12 +9280,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, unsigned int, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::Packet> arg0, unsigned int arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('unsigned int', 'arg1')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9267,12 +9302,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<const ns3::Packet>, unsigned short, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<const ns3::Packet> arg0, short unsigned int arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet const >', 'arg0'), param('short unsigned int', 'arg1')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Ptr__lt__const_ns3Packet__gt___Unsigned_short_Const_ns3Address___amp___Const_ns3Address___amp___Ns3NetDevicePacketType_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9289,12 +9324,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::Ptr<const ns3::Packet>, unsigned short, const ns3::Address &, const ns3::Address &, ns3::NetDevice::PacketType, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::NetDevice> arg0, ns3::Ptr<const ns3::Packet> arg1, short unsigned int arg2, ns3::Address const & arg3, ns3::Address const & arg4, ns3::NetDevice::PacketType arg5) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0'), param('ns3::Ptr< ns3::Packet const >', 'arg1'), param('short unsigned int', 'arg2'), param('ns3::Address const &', 'arg3'), param('ns3::Address const &', 'arg4'), param('ns3::NetDevice::PacketType', 'arg5')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3NetDevice__gt___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9311,12 +9346,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::NetDevice>, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::NetDevice> arg0) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::NetDevice >', 'arg0')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Packet__gt___Double_Ns3UanTxMode_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9333,12 +9368,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, double, ns3::UanTxMode, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Packet> arg0, double arg1, ns3::UanTxMode arg2) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet >', 'arg0'), param('double', 'arg1'), param('ns3::UanTxMode', 'arg2')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Packet__gt___Double_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9355,12 +9390,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, double, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Packet> arg0, double arg1) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet >', 'arg0'), param('double', 'arg1')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Ptr__lt__ns3Packet__gt___Unsigned_short_Const_ns3Mac8Address___amp___Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9377,12 +9412,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Ptr<ns3::Packet>, unsigned short, const ns3::Mac8Address &, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()(ns3::Ptr<ns3::Packet> arg0, short unsigned int arg1, ns3::Mac8Address const & arg2) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Ptr< ns3::Packet >', 'arg0'), param('short unsigned int', 'arg1'), param('ns3::Mac8Address const &', 'arg2')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Time_Ns3Time_Unsigned_int_Unsigned_int_Double_Unsigned_int_Double_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9399,12 +9434,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::Time, ns3::Time, unsigned int, unsigned int, double, unsigned int, double, ns3::empty, ns3::empty>::operator()(ns3::Time arg0, ns3::Time arg1, unsigned int arg2, unsigned int arg3, double arg4, unsigned int arg5, double arg6) [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [param('ns3::Time', 'arg0'), param('ns3::Time', 'arg1'), param('unsigned int', 'arg2'), param('unsigned int', 'arg3'), param('double', 'arg4'), param('unsigned int', 'arg5'), param('double', 'arg6')], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3CallbackImpl__Void_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_Ns3Empty_methods(root_module, cls):
@@ -9421,12 +9456,12 @@
     cls.add_method('GetTypeid', 
                    'std::string', 
                    [], 
-                   is_virtual=True, is_const=True)
+                   is_const=True, is_virtual=True)
     ## callback.h (module 'core'): void ns3::CallbackImpl<void, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty, ns3::empty>::operator()() [member operator]
     cls.add_method('operator()', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True, custom_name='__call__')
+                   custom_name='__call__', is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashImplementation_methods(root_module, cls):
@@ -9438,7 +9473,7 @@
     cls.add_method('GetHash32', 
                    'uint32_t', 
                    [param('char const *', 'buffer'), param('std::size_t const', 'size')], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     ## hash-function.h (module 'core'): uint64_t ns3::Hash::Implementation::GetHash64(char const * buffer, std::size_t const size) [member function]
     cls.add_method('GetHash64', 
                    'uint64_t', 
@@ -9448,7 +9483,7 @@
     cls.add_method('clear', 
                    'void', 
                    [], 
-                   is_virtual=True, is_pure_virtual=True)
+                   is_pure_virtual=True, is_virtual=True)
     return
 
 def register_Ns3HashFunctionFnv1a_methods(root_module, cls):
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/uan/model/uan-header-rc.cc ns-3.33/src/uan/model/uan-header-rc.cc
--- ns-3.32/src/uan/model/uan-header-rc.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/uan/model/uan-header-rc.cc	2021-01-09 10:19:22.000000000 -0800
@@ -96,7 +96,7 @@
 UanHeaderRcData::Serialize (Buffer::Iterator start) const
 {
   start.WriteU8 (m_frameNo);
-  start.WriteU16 ( (uint16_t)(1000.0 * m_propDelay.GetSeconds () + 0.5));
+  start.WriteU16 ( (uint16_t) m_propDelay.RoundTo (Time::MS).GetMilliSeconds ());
 }
 uint32_t
 UanHeaderRcData::Deserialize (Buffer::Iterator start)
@@ -110,9 +110,15 @@
 }
 
 void
+UanHeaderRcData::Print (std::ostream &os, Time::Unit unit) const
+{
+  os << "Frame No=" << (uint32_t) m_frameNo << " Prop Delay=" << m_propDelay.As (unit);
+}
+
+void
 UanHeaderRcData::Print (std::ostream &os) const
 {
-  os << "Frame No=" << (uint32_t) m_frameNo << " Prop Delay=" << m_propDelay.GetSeconds ();
+  Print (os, Time::S);
 }
 
 TypeId
@@ -232,8 +238,7 @@
   start.WriteU8 (m_retryNo);
   start.WriteU8 (m_noFrames);
   start.WriteU16 (m_length);
-  start.WriteU32 ((uint32_t)(m_timeStamp.GetSeconds () * 1000.0 + 0.5));
-  // start.WriteU16(uint16_t (m_timeStamp.GetSeconds ()*1000));
+  start.WriteU32 ((uint32_t) (m_timeStamp.RoundTo (Time::MS).GetMilliSeconds ()));
 }
 
 uint32_t
@@ -250,9 +255,15 @@
 }
 
 void
+UanHeaderRcRts::Print (std::ostream &os, Time::Unit unit) const
+{
+  os << "Frame #=" << (uint32_t) m_frameNo << " Retry #=" << (uint32_t) m_retryNo << " Num Frames=" << (uint32_t) m_noFrames << "Length=" << m_length << " Time Stamp=" << m_timeStamp.As (unit);
+}
+
+void
 UanHeaderRcRts::Print (std::ostream &os) const
 {
-  os << "Frame #=" << (uint32_t) m_frameNo << " Retry #=" << (uint32_t) m_retryNo << " Num Frames=" << (uint32_t) m_noFrames << "Length=" << m_length << " Time Stamp=" << m_timeStamp.GetSeconds ();
+  Print(os, Time::S);
 }
 
 TypeId
@@ -358,8 +369,8 @@
 {
   start.WriteU16 (m_rateNum);
   start.WriteU16 (m_retryRate);
-  start.WriteU32 ( (uint32_t)(m_timeStampTx.GetSeconds () * 1000.0 + 0.5));
-  start.WriteU32 ( (uint32_t)(m_winTime.GetSeconds () * 1000.0 + 0.5));
+  start.WriteU32 ( (uint32_t) (m_timeStampTx.RoundTo (Time::MS).GetMilliSeconds ()));
+  start.WriteU32 ( (uint32_t) (m_winTime.RoundTo (Time::MS).GetMilliSeconds ()));
 }
 
 uint32_t
@@ -375,9 +386,15 @@
 }
 
 void
+UanHeaderRcCtsGlobal::Print (std::ostream &os, Time::Unit unit) const
+{
+  os << "CTS Global (Rate #=" << m_rateNum << ", Retry Rate=" << m_retryRate << ", TX Time=" << m_timeStampTx.As (Time::S) << ", Win Time=" << m_winTime.As (Time::S) << ")";
+}
+
+void
 UanHeaderRcCtsGlobal::Print (std::ostream &os) const
 {
-  os << "CTS Global (Rate #=" << m_rateNum << ", Retry Rate=" << m_retryRate << ", TX Time=" << m_timeStampTx.GetSeconds () << ", Win Time=" << m_winTime.GetSeconds () << ")";
+  Print(os, Time::S);
 }
 
 TypeId
@@ -500,8 +517,8 @@
   start.WriteU8 (address);
   start.WriteU8 (m_frameNo);
   start.WriteU8 (m_retryNo);
-  start.WriteU32 ((uint32_t)(m_timeStampRts.GetSeconds () * 1000.0 + 0.5));
-  start.WriteU32 ((uint32_t)(m_delay.GetSeconds () * 1000.0 + 0.5));
+  start.WriteU32 ((uint32_t) (m_timeStampRts.RoundTo (Time::MS).GetMilliSeconds ()));
+  start.WriteU32 ((uint32_t) (m_delay.RoundTo (Time::MS).GetMilliSeconds ()));
 }
 
 uint32_t
@@ -518,9 +535,15 @@
 }
 
 void
+UanHeaderRcCts::Print (std::ostream &os, Time::Unit unit) const
+{
+  os << "CTS (Addr=" << m_address << " Frame #=" << (uint32_t) m_frameNo << " Retry #=" << (uint32_t) m_retryNo << " RTS Rx Timestamp=" << m_timeStampRts.As (unit) << " Delay until TX=" << m_delay.As (unit) << ")";
+}
+
+void
 UanHeaderRcCts::Print (std::ostream &os) const
 {
-  os << "CTS (Addr=" << m_address << " Frame #=" << (uint32_t) m_frameNo << " Retry #=" << (uint32_t) m_retryNo << " RTS Rx Timestamp=" << m_timeStampRts.GetSeconds () << " Delay until TX=" << m_delay.GetSeconds () << ")";
+  Print (os, Time::S);
 }
 
 TypeId
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/uan/model/uan-header-rc.h ns-3.33/src/uan/model/uan-header-rc.h
--- ns-3.32/src/uan/model/uan-header-rc.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/uan/model/uan-header-rc.h	2021-01-09 10:19:22.000000000 -0800
@@ -86,6 +86,13 @@
    * \note Prop. delay is transmitted with 16 bits and ms accuracy
    */
   Time GetPropDelay (void) const;
+  /**
+   * Specialized Print with Time::Unit declared.
+   *
+   * \param os ostream.
+   * \param unit Time unit.
+   */
+  void Print (std::ostream &os, Time::Unit unit) const;
 
   // Inherrited methods
   virtual uint32_t GetSerializedSize (void) const;
@@ -197,6 +204,13 @@
    * \return The retry number.
    */
   uint8_t GetRetryNo (void) const;
+   /**
+   * Specialized Print with Time::Unit declared.
+   *
+   * \param os ostream.
+   * \param unit Time unit.
+   */
+  void Print (std::ostream &os, Time::Unit unit) const;
 
   // Inherrited methods
   virtual uint32_t GetSerializedSize (void) const;
@@ -294,6 +308,13 @@
    * \return The timestamp.
    */
   Time GetTxTimeStamp (void) const;
+  /**
+   * Specialized Print with Time::Unit declared.
+   *
+   * \param os ostream.
+   * \param unit Time unit.
+   */
+  void Print (std::ostream &os, Time::Unit unit) const;
 
   // Inherrited methods
   virtual uint32_t GetSerializedSize (void) const;
@@ -405,6 +426,13 @@
    * \return The destination address.
    */
   Mac8Address GetAddress (void) const;
+  /**
+   * Specialized Print with Time::Unit declared.
+   *
+   * \param os ostream.
+   * \param unit Time unit.
+   */
+  void Print (std::ostream &os, Time::Unit unit) const;
 
   // Inherrited methods
   virtual uint32_t GetSerializedSize (void) const;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/uan/model/uan-mac-rc-gw.cc ns-3.33/src/uan/model/uan-mac-rc-gw.cc
--- ns-3.32/src/uan/model/uan-mac-rc-gw.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/uan/model/uan-mac-rc-gw.cc	2021-01-09 10:19:22.000000000 -0800
@@ -301,7 +301,7 @@
   // Calculate dataRate
   uint32_t totalBytes = 0;
   uint32_t totalFrames = 0;
-  double pDelay = 0;
+  Time pDelay = Seconds (0);
   if (numRts > 0)
     {
       std::map<Mac8Address, Request>::iterator rit = m_requests.begin ();
@@ -310,7 +310,7 @@
           totalBytes += (*rit).second.length;
           totalFrames += (*rit).second.numFrames;
         }
-      pDelay = 2 * m_sortedRes.begin ()->first.GetSeconds ();
+      pDelay = 2 * m_sortedRes.begin ()->first;
     }
 
 
@@ -321,7 +321,7 @@
     {
       optA = FindOptA ();
     }
-  double thAlpha = ComputeAlpha (totalFrames, totalBytes, m_numNodes, optA, pDelay / 2.0);
+  double thAlpha = ComputeAlpha (totalFrames, totalBytes, m_numNodes, optA, (pDelay / 2.0).GetSeconds ());
 
   double thCtlRate = m_totalRate * thAlpha;
 
@@ -353,23 +353,24 @@
   uint32_t ctlRate =  m_phy->GetMode (m_currentRateNum + m_numRates).GetDataRateBps ();
 
 
-  double winSize = (double)(totalBytes) * 8.0 / dataRate + m_sifs.GetSeconds () * totalFrames + pDelay;
+  Time winSize = Seconds (totalBytes * 8.0 / dataRate) + m_sifs * totalFrames + pDelay; 
   if (numRts == 0)
     {
-      winSize = (optA * std::exp (1.0) + 0.5) * 2.0 * 8.0 * m_rtsSize / (thAlpha * m_totalRate) + 2 * m_maxDelta.GetSeconds ();
+      winSize = Seconds ((optA * std::exp (1.0) + 0.5) * 2.0 * 8.0 * m_rtsSize / (thAlpha * m_totalRate)) + (2 * m_maxDelta); 
     }
-  double effWinSize = winSize - m_rtsSize * 8 / ctlRate  - 2 * m_maxDelta.GetSeconds ();
-
+  Time effWinSize = winSize - Seconds (m_rtsSize * 8 / ctlRate)  - (2 * m_maxDelta);
 
   // Before fast CTS/ACK(below)
-  double cycleSeconds = winSize + (totalFrames + 1.0) * m_sifs.GetSeconds () + m_ctsSizeG * 8.0 / dataRate + (m_ctsSizeN + m_ackSize) * 8.0 * numRts / dataRate;
-
   Time ctsTxTimeG = Seconds (m_ctsSizeG * 8.0 / dataRate);
+  Time cycleSeconds = winSize + ((totalFrames + 1.0) * m_sifs) +
+    ctsTxTimeG + Seconds ((m_ctsSizeN + m_ackSize) * 8.0 / dataRate);    
+
+
   Time ctsTxTimeTotal = Seconds (m_ctsSizeN * 8.0 * numRts / dataRate) + ctsTxTimeG;
   if (numRts == 0)
     {
       UanHeaderRcCtsGlobal ctsg;
-      ctsg.SetWindowTime (Seconds (effWinSize));
+      ctsg.SetWindowTime (effWinSize);
       ctsg.SetRateNum (static_cast<uint16_t> (m_currentRateNum));
       ctsg.SetRetryRate (m_currentRetryRate);
       ctsg.SetTxTimeStamp (Simulator::Now ());
@@ -386,9 +387,9 @@
       SendPacket (p, m_currentRateNum);
 
 
-      Simulator::Schedule (Seconds (cycleSeconds), &UanMacRcGw::StartCycle, this);
+      Simulator::Schedule (cycleSeconds, &UanMacRcGw::StartCycle, this);
       m_state = INCYCLE;
-      m_cycleLogger (Simulator::Now (), Seconds (0), numRts, totalBytes, effWinSize, ctlRate, actualX);
+      m_cycleLogger (Simulator::Now (), Seconds (0), numRts, totalBytes, effWinSize.GetSeconds (), ctlRate, actualX);
       return;
     }
 
@@ -433,7 +434,7 @@
   UanHeaderRcCtsGlobal ctsg;
   ctsg.SetRateNum (static_cast<uint16_t> (m_currentRateNum));
   ctsg.SetRetryRate (m_currentRetryRate);
-  ctsg.SetWindowTime (Seconds (effWinSize));
+  ctsg.SetWindowTime (effWinSize);
   ctsg.SetTxTimeStamp (Simulator::Now ());
   UanHeaderCommon ch;
   ch.SetDest (Mac8Address::GetBroadcast ());
@@ -448,7 +449,7 @@
   Simulator::Schedule (nextEarliest, &UanMacRcGw::EndCycle, this);
 
 
-  m_cycleLogger (Simulator::Now (), minPdelay, numRts, totalBytes, cycleSeconds, ctlRate, actualX);
+  m_cycleLogger (Simulator::Now (), minPdelay, numRts, totalBytes, cycleSeconds.GetSeconds (), ctlRate, actualX);
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/uan/model/uan-phy-gen.cc ns-3.33/src/uan/model/uan-phy-gen.cc
--- ns-3.32/src/uan/model/uan-phy-gen.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/uan/model/uan-phy-gen.cc	2021-01-09 10:19:22.000000000 -0800
@@ -170,8 +170,7 @@
       // times, the offset in terms of the arriving symbol power is
       // 0.3 symbol+clearing times.
 
-      int32_t syms = (uint32_t)(tDelta / (ts + clearingTime)).GetHigh ();
-      tDelta = tDelta - syms * (ts + clearingTime);
+      tDelta = Rem (tDelta, ts + clearingTime);
 
       // Align to pktRx
       if (arrTime + maxTapDelay  > it->GetArrivalTime ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/uan/model/uan-prop-model.cc ns-3.33/src/uan/model/uan-prop-model.cc
--- ns-3.32/src/uan/model/uan-prop-model.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/uan/model/uan-prop-model.cc	2021-01-09 10:19:22.000000000 -0800
@@ -220,7 +220,7 @@
           maxTapIndex = i;
         }
     }
-  uint32_t start = maxTapIndex + static_cast<uint32_t> (delay.GetSeconds () / m_resolution.GetSeconds ());
+  uint32_t start = maxTapIndex + (delay / m_resolution).GetHigh ();
   uint32_t end = std::min (start + numTaps, GetNTaps ());
   std::complex<double> sum = 0;
   for (uint32_t i = start; i < end; i++)
@@ -241,7 +241,7 @@
       return 0;
     }
 
-  uint32_t numTaps =  static_cast<uint32_t> (duration.GetSeconds () / m_resolution.GetSeconds () + 0.5);
+  uint32_t numTaps =  (duration / m_resolution + 0.5).GetHigh ();
   double maxAmp = -1;
   uint32_t maxTapIndex = 0;
 
@@ -255,7 +255,7 @@
     }
 
 
-  uint32_t start = maxTapIndex + static_cast<uint32_t> (delay.GetSeconds () / m_resolution.GetSeconds ());
+  uint32_t start = maxTapIndex + (delay / m_resolution).GetHigh ();
   uint32_t end = std::min (start + numTaps, GetNTaps ());
   double sum = 0;
   for (uint32_t i = start; i < end; i++)
@@ -283,8 +283,8 @@
         }
     }
 
-  uint32_t stIndex = (uint32_t)(begin.GetSeconds () / m_resolution.GetSeconds () + 0.5);
-  uint32_t endIndex = (uint32_t)(end.GetSeconds () / m_resolution.GetSeconds () + 0.5);
+  uint32_t stIndex = (begin / m_resolution + 0.5).GetHigh ();
+  uint32_t endIndex = (end / m_resolution + 0.5).GetHigh ();
 
   endIndex = std::min (endIndex, GetNTaps ());
   double sum = 0;
@@ -316,8 +316,8 @@
         }
     }
 
-  uint32_t stIndex = (uint32_t)(begin.GetSeconds () / m_resolution.GetSeconds () + 0.5);
-  uint32_t endIndex = (uint32_t)(end.GetSeconds () / m_resolution.GetSeconds () + 0.5);
+  uint32_t stIndex = (begin / m_resolution + 0.5).GetHigh ();
+  uint32_t endIndex = (end / m_resolution + 0.5).GetHigh ();
 
   endIndex = std::min (endIndex, GetNTaps ());
 
